<template>

  <Head>
    <title>Add New Role - GreenK Cashier</title>
  </Head>
  <main class="c-main">
    <div class="container-fluid">
      <div class="fade-in">
        <div class="row">
          <div class="col-md-12">
            <div class="card border-0 rounded-3 shadow border-top-purple">
              <div class="card-header bg-primary text-white">
                <span class="font-weight-bold"><i class="fa fa-shield-alt me-2"></i> ADD ROLE</span>
              </div>
              <div class="card-body">

                <!-- form create role -->
                <form @submit.prevent="submit">

                  <!-- role name -->
                  <div class="mb-3">
                    <label class="fw-bold">Role Name</label>
                    <input class="form-control" v-model="form.name" :class="{ 'is-invalid': errors.name }" type="text"
                      placeholder="Role Name">
                  </div>
                  <div v-if="errors.name" class="text-danger mb-3" style="margin-top: -15px">
                    <small><strong>{{ errors.name }}</strong></small>
                  </div>

                  <!-- permissions -->
                  <div class="mb-3">
                    <label class="fw-bold">Permissions</label>
                    <br>
                    <div class="form-check form-check-inline" v-for="(permission, index) in permissions" :key="index">
                      <input class="form-check-input my-1" type="checkbox" v-model="form.permissions"
                        :value="permission.name" :id="`check-${permission.id}`">
                      <label class="form-check-label" :for="`check-${permission.id}`">{{
                        permission.name
                      }}</label>
                    </div>
                  </div>
                  <div v-if="errors.permissions" class="text-danger mb-3" style="margin-top: -15px">
                    <small><strong>{{ errors.permissions }}</strong></small>
                  </div>

                  <!-- button submit -->
                  <div class="row">
                    <div class="col-12">
                      <button class="btn btn-primary btn-md shadow-sm rounded" type="submit">SAVE</button>
                    </div>
                  </div>
                </form>

              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<script>
// import layout
import LayoutApp from '../../../Layouts/App.vue'

// import Head and useForm from inertia
import { Head, Link } from '@inertiajs/vue3'

//import reactive from vue
import { reactive } from 'vue'

//import inerita adapter
import { router } from '@inertiajs/vue3';

//import sweet alert2
import Swal from 'sweetalert2';

export default {
  // layout
  layout: LayoutApp,

  // register component
  components: {
    Head,
    Link,
  },

  // props
  props: {
    errors: Object,
    permissions: Array,
    role: Object,
  },

  // composition api
  setup(props) {
    // define form with reactive
    const form = reactive({
      name: props.role.name,
      permissions: props.role.permissions.map(obj => obj.name),
    });

    // method submit
    const submit = () => {
      // send data to server
      router.put(`/apps/roles/${props.role.id}`, {
        // data
        name: form.name,
        permissions: form.permissions,
      }, {
        onSuccess: () => {
          // show success alert
          Swal.fire({
            title: 'Updated!',
            text: 'Role has been updated.',
            icon: 'success',
            showConfirmButton: false,
            timer: 2000
          })
        }
      })
    }

    // return
    return {
      submit,
      form,
    }
  }
}
</script>

<style>

</style>